MMEvents.createStructures(event => {
    event.create("mm:reaction_chamber")
        .controllerId("mm:reaction_chamber")
        .name("Reaction Chamber")
        .layout(a => {
            a.layer([
                "BBB",
                "BBB",
                "BBB",
                "   ",
                "   ",
                "   ",
                "   ",
                "   ",
                "BBB",
                "BBB",
                "BBB"
            ]).layer([
                "BBB",
                "BBB",
                "BBB",
                "DDD",
                "DDD",
                "DKI",
                "DDD",
                "DDD",
                "BBB",
                "BBB",
                "BBB"
            ]).layer([
                "BBB",
                "BBB",
                "BBB",
                "DEF",
                "DGH",
                "CDJ",
                "DGH",
                "DEF",
                "BBB",
                "BBB",
                "BBB"
            ]).layer([
                "AAA",
                "AAA",
                "AAA",
                "AAA",
                "AAA",
                "AAA",
                "AAA",
                "AAA",
                "AAA",
                "AAA",
                "AAA"
            ])
        .key("A", {
            block: "create:copper_casing"
        })
        .key("B", {
            block: "create:fluid_tank"
        })
        .key("D", {
            block: "create:brass_casing"
        })
        .key("E", {
            block: "create:mechanical_pump"
        })
        .key("F", {
            block: "create:brass_encased_cogwheel"
        })
        .key("G", {
            tag: "impostor:fluid_port_input",
            input: true
        })
        .key("I", {
            tag: "impostor:fluid_port_output",
            input: false
        })
        .key("H", {
            block: "create:brass_encased_shaft"
        })
        .key("J", {
            block: "createcasing:brass_gearbox"
        })
        .key("K", {
            tag: "impostor:item_port_input",
            input: true
        })
    })
})

ServerEvents.recipes(event => {
    //Reaction Chamber Controller
    event.shaped('mm:reaction_chamber',
        ['BEB', 'RCR', 'BFB'], {
        B: 'create:brass_casing',       // Advanced casing for corners
        E: 'create:mechanical_pump',    // Essential for fluid processing
        R: '#forge:storage_blocks/redstone', // For powering the mechanism
        C: 'minecraft:nether_star',     // Represents the central powerful catalyst
        F: 'create:fluid_tank'          // Fluid storage capability
    }).id('mm:reaction_chamber_controller')
})